<?php

namespace Bnpparibas\Axepta\Block\Customer;

/**
 * 1997-2020 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */
class Subscriptions extends \Magento\Framework\View\Element\Template
{

    protected $dataHelper;

    protected $product;

    /**
     * Construct
     *
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Bnpparibas\Axepta\Helper\Data $dataHelper,
        \Magento\Catalog\Model\Product $product,
        array $data = []
    ) {
        $this->dataHelper = $dataHelper;
        $this->product = $product;
        parent::__construct($context, $data);
    }

    public function getAllSubscriptionsByCustomer()
    {
        return $this->dataHelper->getCustomerRecurringPayementList();
    }

    public function loadProduct($productId)
    {
        return $this->product->load($productId);
    }
}
