<?php
/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */

namespace Bnpparibas\Axepta\Controller\Adminhtml\CustomerRecurringPayment;

use Bnpparibas\Axepta\Model\ResourceModel\CustomerRecurringPayment as CustomerRecurringPaymentResource;
use Bnpparibas\Axepta\Model\CustomerRecurringPaymentFactory;
use Magento\Backend\App\Action;

class Delete extends Action
{

    private $customerRecurringPaymentFactory;
    private $customerRecurringPaymentResource;

    public function __construct(
        Action\Context $context,
        CustomerRecurringPaymentFactory $customerRecurringPaymentFactory,
        CustomerRecurringPaymentResource $customerRecurringPaymentResource
    ) {
        parent::__construct($context);
        $this->customerRecurringPaymentFactory = $customerRecurringPaymentFactory;
        $this->customerRecurringPaymentResource = $customerRecurringPaymentResource;
    }

    public function execute()
    {
        if ($id = $this->getRequest()->getParam('id')) {
            $payment = $this->customerRecurringPaymentFactory->create();
            $this->customerRecurringPaymentResource->load($payment, $id);
            $this->customerRecurringPaymentResource->delete($payment);
        }

        $this->messageManager->addSuccessMessage(__('Recurring payment deleted'));

        return $this->resultRedirectFactory->create()->setPath('*/customerrecurringpayment/');
    }
}
