<?php

namespace Bnpparibas\Axepta\Controller\Adminhtml\CustomerRecurringPayment;

use Bnpparibas\Axepta\Model\ResourceModel\CustomerRecurringPayment as CustomerRecurringPaymentResource;
use Bnpparibas\Axepta\Model\ResourceModel\CustomerRecurringPayment\CollectionFactory;
use Magento\Backend\App\Action;
use Magento\Ui\Component\MassAction\Filter;

class MassDisable extends Action
{

    /**
     * @var Filter
     */
    private $filter;
    
    private $collectionFactory;
    private $customerRecurringPaymentResource;

    public function __construct(
        Action\Context $context,
        Filter $filter,
        CollectionFactory $collectionFactory,
        CustomerRecurringPaymentResource $customerRecurringPaymentResource
    ) {
        parent::__construct($context);
        $this->filter = $filter;
        $this->collectionFactory = $collectionFactory;
        $this->customerRecurringPaymentResource = $customerRecurringPaymentResource;
    }

    public function execute()
    {
        $collection = $this->filter->getCollection($this->collectionFactory->create());

        foreach ($collection as $payment) {
            $payment->setStatus(3);
            $payment->save();
        }

        $this->messageManager->addSuccessMessage(__('Recurring payments disable'));

        return $this->resultRedirectFactory->create()->setPath('*/customerrecurringpayment/');
    }
}
