<?php

namespace Bnpparibas\Axepta\Controller\Adminhtml\MerchantAccount;

use Bnpparibas\Axepta\Model\ResourceModel\MerchantAccount as ResourceMerchantAccount;
use Bnpparibas\Axepta\Model\ResourceModel\MerchantAccount\CollectionFactory;
use Magento\Backend\App\Action;
use Magento\Ui\Component\MassAction\Filter;

class MassDelete extends Action
{

    /**
     * @var Filter
     */
    private $filter;

    /**
     * @var CollectionFactory
     */
    private $collectionFactory;

    /**
     * @var ResourceMerchantAccount
     */
    private $resourceMerchantAccount;

    public function __construct(
        Action\Context $context,
        Filter $filter,
        CollectionFactory $collectionFactory,
        ResourceMerchantAccount $resourceMerchantAccount
    ) {
        parent::__construct($context);
        $this->filter = $filter;
        $this->collectionFactory = $collectionFactory;
        $this->resourceMerchantAccount = $resourceMerchantAccount;
    }

    public function execute()
    {
        $collection = $this->filter->getCollection($this->collectionFactory->create());

        foreach ($collection as $slide) {
            $this->resourceMerchantAccount->delete($slide);
        }

        $this->messageManager->addSuccessMessage(__('Accounts deleted'));

        return $this->resultRedirectFactory->create()->setPath('*/paymentsetup/');
    }
}
