<?php
/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */

namespace Bnpparibas\Axepta\Controller\Adminhtml\Xml;

class Import extends \Magento\Backend\App\Action
{

    protected $xml;

    public function __construct(
        \Bnpparibas\Axepta\Model\Api\Xml $xml
    ) {
        $this->xml = $xml;
    }
    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return true;
    }

    /**
     * Import action
     * @return \Magento\Backend\Model\View\Result\Page
     */
    public function execute()
    {
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();

        try {
            if ($this->xml->importXml()) {
                $this->messageManager->addSuccess(__('Import successful'));
            } else {
                $this->messageManager->addError(__('Failed to import'));
            }
        } catch (\Exception $e) {
            $this->messageManager->addError(__('Failed to import') . ': ' . $e->getMessage());
        }

        return $resultRedirect->setPath('axepta/paymentsetup/index');
    }
}
