<?php

/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */

namespace Bnpparibas\Axepta\Controller\Checkout;

class Ajax extends \Magento\Framework\App\Action\Action
{

    /** @var \Magento\Framework\Controller\Result\JsonFactory */
    protected $resultJsonFactory;
    private $checkoutSession;
    private $configProvider;

    /**
     * @param Action\Context $context
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Bnpparibas\Axepta\Model\AxeptaConfigProvider $configProvider
    ) {
        $this->resultJsonFactory = $resultJsonFactory;
        $this->checkoutSession = $checkoutSession;
        $this->configProvider = $configProvider;

        parent::__construct($context);
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return true;
    }

    /**
     * Execute Ajax
     *
     * @return \Magento\Backend\Model\View\Result\Page|\Magento\Backend\Model\View\Result\Redirect
     * @SuppressWarnings(PHPMD.NPathComplexity)
     */
    public function execute()
    {
        // Ajax
        $isAjax = $this->getRequest()->getParam('isAjax');
        if ($isAjax == true) {
            $action = $this->getRequest()->getParam('action');
            $resultAction = $this->$action();
            $result = $this->resultJsonFactory->create();
            return $result->setData($resultAction);
        }
    }

    /* AJAX CALL */
    public function getAllowedMethods()
    {
        $isoCountry = $this->getRequest()->getParam('countryId');
        $allowedMethod = $this->configProvider->getConfig($isoCountry);
        return $allowedMethod;
    }
}
