<?php

namespace Bnpparibas\Axepta\Controller\Customer;

/**
 * 1997-2020 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */
class Cards extends \Magento\Framework\App\Action\Action
{

    protected $customerOneclickPaymentCardFactory;
    protected $_resourceCustomerOneclickPaymentCard;
    protected $customerSession;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Bnpparibas\Axepta\Model\CustomerOneclickPaymentCard $customerOneclickPaymentCard,
        \Magento\Customer\Model\Session $customerSession
    ) {
        $this->customerOneclickPaymentCardFactory = $customerOneclickPaymentCard;
        $this->customerSession = $customerSession;
        return parent::__construct($context);
    }

    public function execute()
    {
        if ($id = $this->getRequest()->getParam('id')) {

            try {
                $model = $this->customerOneclickPaymentCardFactory->load($id);

                if (is_null($model->getId())) {
                    $this->messageManager->addErrorMessage(__('Card not deleted'));
                } else {
                    if ($model->getCustomerId() == $this->customerSession->getCustomer()->getId()) {
                        $model->delete();
                        $this->messageManager->addSuccessMessage(__('Card deleted'));
                    } else {
                        $this->messageManager->addErrorMessage(__('Card not deleted'));
                    }
                }
            } catch (Exception $e) {
                $this->messageManager->addErrorMessage($e->getMessage());
            }
        }

        $this->_view->loadLayout();
        $this->_view->renderLayout();
    }
}
