<?php

namespace Bnpparibas\Axepta\Controller\Customer;

/**
 * 1997-2020 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */
class Subscriptions extends \Magento\Framework\App\Action\Action
{

    protected $customerRecurringPaymentFactory;
    protected $customerSession;

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Bnpparibas\Axepta\Model\CustomerRecurringPayment $customerRecurringPayment,
        \Magento\Customer\Model\Session $customerSession
    ) {
        $this->customerRecurringPaymentFactory = $customerRecurringPayment;
        $this->customerSession = $customerSession;
        return parent::__construct($context);
    }

    public function execute()
    {
        if ($id = $this->getRequest()->getParam('id')) {

            try {
                $model = $this->customerRecurringPaymentFactory->load($id);

                if (is_null($model->getId())) {
                    $this->messageManager->addErrorMessage(__('Subscription not disabled'));
                } else {
                    if ($model->getCustomerId() == $this->customerSession->getCustomer()->getId() && $model->getStatus() == 1) {
                        $model->setStatus(3);
                        $model->save();
                        $this->messageManager->addSuccessMessage(__('Subscription disabled'));
                    } elseif ($model->getCustomerId() == $this->customerSession->getCustomer()->getId() && $model->getStatus() == 3) {
                        $model->setStatus(1);
                        $model->save();
                        $this->messageManager->addSuccessMessage(__('Subscription enable'));
                    } else {
                        $this->messageManager->addErrorMessage(__('Subscription not disabled'));
                    }
                }
            } catch (Exception $ex) {
                $this->messageManager->addErrorMessage($e->getMessage());
            }
            return $this->resultRedirectFactory->create()->setPath('axepta/customer/subscriptions');
        }

        $this->_view->loadLayout();
        $this->_view->renderLayout();
    }
}
