<?php

/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */

namespace Bnpparibas\Axepta\Model\Api;

class Service extends \Magento\Framework\Model\AbstractModel
{

    const AXEPTA_LOG_ACTIVE= 'bnpparibas_axepta/api/log_active';

    /** @var \Magento\Framework\HTTP\Client\Curl */
    protected $curl;

    /** @var \Psr\Log\LoggerInterface */
    protected $logger;

    protected $_isLogActive;

    protected $scopeConfig;

    /**
     * Logger
     *
     * @var LoggerInterface
     */
    protected $loggerAxepta;

    /** @var array */
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\HTTP\Client\Curl $curl,
        \Psr\Log\LoggerInterface $logger,
        \Bnpparibas\Axepta\Logger\Logger $loggerAxepta
    ) {
        $this->scopeConfig = $scopeConfig;
        $this->curl = $curl;
        $this->logger = $logger;
        $this->loggerAxepta = $loggerAxepta;

        $this->_isLogActive = $this->scopeConfig->getValue(
            self::AXEPTA_LOG_ACTIVE,
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
    }
    
    public function axeptaApiCurlCall($url, $postFields)
    {
        try {
            if ($this->_isLogActive) {
                $this->loggerAxepta->info(__METHOD__  . " - Url : $url");
                $this->loggerAxepta->info(print_r($postFields, true));
            }
            
            $this->curl->post($url, $postFields);
            $response = $this->curl->getBody();
            return $response;
        } catch (Exception $e) {
            $this->logger->critical('Error Curl', ['exception' => $e]);
        }
    }
}
