<?php
/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */
namespace Bnpparibas\Axepta\Model\MerchantAccount\Config\Source;

class CaptureMethods implements \Magento\Framework\Option\ArrayInterface
{
    
    private $countryFactory;
    
    public function __construct(
        \Bnpparibas\Axepta\Model\CountryFactory $countryFactory
    ) {
        $this->countryFactory = $countryFactory;
    }
    
    /**
     * Get available options
     *
     * @codeCoverageIgnore
     * @return array
     */
    public function toOptionArray()
    {
        return [
            ['value' => 'auto', 'label' => __('Automatic capture payment (by default)')],
            ['value' => 'timed', 'label' => __('Capture after time defined')],
            ['value' => 'manual', 'label' => __('Manual capture')]
        ];
    }
}
