<?php

/**
 * 1997-2019 Quadra Informatique
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0) that is available
 * through the world-wide-web at this URL: http://www.opensource.org/licenses/OSL-3.0
 * If you are unable to obtain it through the world-wide-web, please send an email
 * to modules@quadra-informatique.fr so we can send you a copy immediately.
 *
 * @author    Quadra Informatique <modules@quadra-informatique.fr>
 * @copyright 1997-2019 Quadra Informatique
 * @license   http://www.opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 *
 * @category    Bnp
 * @package     Bnpparibas_Axepta
 */

namespace Bnpparibas\Axepta\Model\MerchantAccount;

use Bnpparibas\Axepta\Model\ResourceModel\MerchantAccount\CollectionFactory as MerchantAccountFactory;
use Magento\Framework\App\Request\DataPersistorInterface;
use Magento\Ui\DataProvider\AbstractDataProvider;

class DataProvider extends AbstractDataProvider
{

    protected $loadedData = [];

    /**
     * @var Collection $collection
     */
    protected $collection;
    
    /**
     * @var DataPersistorInterface
     */
    protected $dataPersistor;

    
    public function __construct(
        $name,
        $primaryFieldName,
        $requestFieldName,
        MerchantAccountFactory $collection,
        DataPersistorInterface $dataPersistor,
        array $meta = [],
        array $data = []
    ) {
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
        $this->collection = $collection->create();
        $this->dataPersistor = $dataPersistor;
    }

    public function getData()
    {
        if (!empty($this->loadedData)) {
            return $this->loadedData;
        }
        
        $items = $this->collection->getItems();
        
        foreach ($items as $account) {
            $result['axepta_merchantaccount'] = $account->getData();
            $this->loadedData[$account->getId()] = $result;
        }
        
        return $this->loadedData;
    }
}
