<?php
namespace Bnpparibas\Axepta\Ui\Component\Listing\Columns;

use \Magento\Sales\Api\OrderRepositoryInterface;
use \Magento\Framework\View\Element\UiComponent\ContextInterface;
use \Magento\Framework\View\Element\UiComponentFactory;
use \Magento\Ui\Component\Listing\Columns\Column;
use \Magento\Framework\Api\SearchCriteriaBuilder;

class CaptureStatus extends Column
{
    protected $orderRepository;
    protected $searchCriteria;

    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        OrderRepositoryInterface $orderRepository,
        SearchCriteriaBuilder $criteria,
        array $components = [],
        array $data = []
    ) {
        $this->orderRepository = $orderRepository;
        $this->searchCriteria  = $criteria;
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as & $item) {

                $order = $this->orderRepository->get($item['entity_id']);
                $paymentInformations = $order->getPayment()->getAdditionalInformation();

                $captureType = '';
                if (array_key_exists('captureMode', $paymentInformations)) {
                    $captureType = __('No');
                    if ($order->hasInvoices()) {
                        $captureType = __('Yes');
                    }

                    if ($paymentInformations['captureMode'] === 'timed' && array_key_exists('captureTimed', $paymentInformations)) {
                        date_default_timezone_set("Europe/Paris");
                        $date_now = date('Y-m-d H:i:s');
                        if ($date_now > $paymentInformations['captureTimed']) {
                            $captureType = __('Yes');
                        } else {
                            $captureType = __('No');
                        }
                    }
                }

                $item[$this->getData('name')] = $captureType;
            }
        }

        return $dataSource;
    }
}
