<?php

namespace Bnpparibas\Axepta\Ui\Component\Listing\Columns;

use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;

class CustomerRecurringPaymentActions extends Column
{

    /**
     * @var UrlInterface
     */
    private $urlBuilder;

    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        UrlInterface $urlBuilder,
        array $components = [],
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        parent::__construct($context, $uiComponentFactory, $components, $data);
    }

    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                $item[$this->getData('name')]['enable'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'axepta/customerrecurringpayment/enable',
                        ['id' => $item['id']]
                    ),
                    'label' => __('Enable'),
                ];
                $item[$this->getData('name')]['disable'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'axepta/customerrecurringpayment/disable',
                        ['id' => $item['id']]
                    ),
                    'label' => __('Disable'),
                ];
                $item[$this->getData('name')]['delete'] = [
                    'href' => $this->urlBuilder->getUrl(
                        'axepta/customerrecurringpayment/delete',
                        ['id' => $item['id']]
                    ),
                    'label' => __('Delete'),
                ];
            }
        }

        return $dataSource;
    }
}
