define([
    "jquery",
    "mage/translate",
    "loader",
    "mage/gallery/gallery",
    "jquery/ui",
    "mage/validation",
    "prototype"
], function ($, $t, Loader, Gallery) {
    'use strict';

    // Prefix
    var prefix = 'merchantaccount_';
    var prefix_tab = 'edit_tabs_';
    var prefix_field = 'field-';

    var elements = {
        'capture_mode': $('#' + prefix + 'capture_mode'),
        'capture_time': $('#' + prefix + 'capture_time')
    }

    var tabs = {
        'capture_mode': $('.' + prefix_field + 'capture_mode'),
        'capture_time': $('.' + prefix_field + 'capture_time')
    }

    // Init Form
    toogleCaptureTime();

    // Update
    elements.capture_mode.change(function() {
        toogleCaptureTime();
    });

    function toogleCaptureTime() {
        if (elements.capture_mode.val() === 'timed') {
            tabs.capture_time.show();
        } else {
            tabs.capture_time.hide();
        }

        if (elements.capture_mode.val() === 'manual') {
            $("#capture_mode-note").show();
        } else {
            $("#capture_mode-note").hide();
        }
    }

});
