define([
    'jquery',
    'Magento_Customer/js/model/customer',
    'mage/url',
    'Bnpparibas_Axepta/js/view/payment/method-renderer/axepta-method'
], function ($, customer, url, Component) {
    'use strict';

    $(document).on('click', '#axepta-recurring-payment-method .more-option-btn', function(){
        var is_selected = $(this).hasClass('selected');
        
        if (is_selected) {
            $(this).removeClass('selected');
            $('#hidden-method').slideUp("500");
            $('#axepta-recurring-payment-method .more-option-btn span.more-options').show();
            $('#axepta-recurring-payment-method .more-option-btn span.less-options').hide();
        } else {
            $(this).addClass('selected');
            $('#hidden-method').slideDown("500");
            $('#axepta-recurring-payment-method .more-option-btn span').html($(this).data('expended-content'));
            $('#axepta-recurring-payment-method .more-option-btn span.more-options').hide();
            $('#axepta-recurring-payment-method .more-option-btn span.less-options').show();
        }
    });

    return Component.extend({
        defaults: {
            template: 'Bnpparibas_Axepta/payment/axepta-recurring'
        },
        operation: "recurring",
        methodData: null,
        event: null,
        parent: null,

        saveDataChecked: function (parent, event, methodData) {
            this.parent = parent;
            this.event = event;
            this.methodData = methodData;
            $("#" + methodData.code).prop("checked", true);
            $("#action-checkout").removeClass("disabled");
        },

        placeOrder() {
            delete this.methodData.images;
            this.methodData.isRecurringPayment = "1";

            return this._super(this.parent, this.event, this.methodData);
        },

        isRecurringActive() {
            return this.recurring();
        },

        getCreateCustomerUrl: function () {
            return url.build('customer/account/create');
        },

        isCustomerGuest: function () {
            return !customer.isLoggedIn();
        },

        getCode: function () {
            return 'axepta_recurring';
        }
    });
});
