define([
    'jquery',
    'Magento_Checkout/js/model/quote',
    'ko',
    'mage/url',
    'Magento_Checkout/js/action/select-billing-address',
    'Bnpparibas_Axepta/js/view/payment/method-renderer/axepta-method'
], function ($, quote, ko, url, selectBillingAddress, AxeptaMethod) {
    'use strict';
    var mixin = {
        /**
         * @return {Boolean}
         */
        validateShippingInformation: function () {
            var result = this._super();
            selectBillingAddress(quote.shippingAddress());
            var selectedAddress = quote.billingAddress();
            if (selectedAddress === null) {
                selectedAddress = quote.shippingAddress();
            }

            var countryId = (selectedAddress.countryId !== undefined) ?
                selectedAddress.countryId : $("[name='country_id']").val();

            $.ajax({
                url: url.build('axepta/checkout/ajax/'),
                type: "POST",
                dataType: "json",
                data: {
                    isAjax: true,
                    action: 'getAllowedMethods',
                    countryId: countryId
                },
                success: function (data) {
                    window.checkoutConfig.axepta = data.axepta;
                    AxeptaMethod.call().loadPaymentMethods(data.axepta);
                    
                }
            });

            return result;
        }
    };

    return function (target) {
        return target.extend(mixin);
    };
});